// setcolor.cpp : Defines the entry point for the console application.
//
#include "windows.h"
#include "wincon.h"
#include <stdio.h>

#define _MAX_CMD_LINE_ARGS  128

extern "C" {

//char usageinfo[] = "Usage: setcolor <outcolor> <stderr color>\r\nWhere <color> is two characters - first foreground, second background\r\n";
char * _ppszArgv[_MAX_CMD_LINE_ARGS+1];

int __cdecl _ConvertCommandLineToArgcArgv( void );
void SetColor(HANDLE h, char* pstr);

int __stdcall main(void)
{
	HANDLE h;
	int argc;
	
	argc = _ConvertCommandLineToArgcArgv();


	if (argc < 2) {
	//	DWORD written;
	//	h=GetStdHandle(STD_OUTPUT_HANDLE);
	//	if (h!=INVALID_HANDLE_VALUE) {
	//		WriteConsole(h, usageinfo, lstrlen(usageinfo), &written, NULL);
	//		CloseHandle(h);
	//	}
		return 0;
	}
	if (argc > 1) {
		h = GetStdHandle(STD_OUTPUT_HANDLE);
		if (h!=INVALID_HANDLE_VALUE) {
			SetColor(h,_ppszArgv[1]);
			CloseHandle(h);
		}
	}
	if (argc > 2) {
		h = GetStdHandle(STD_ERROR_HANDLE);
		if (h!=INVALID_HANDLE_VALUE) {
			SetColor(h,_ppszArgv[2]);
			CloseHandle(h);
		}
	}
	return 0;
}

void SetColor(HANDLE h, char* pstr) {
	char foreground = *pstr;
	if (foreground == '\0') return;
	char background = *(pstr+1);
	if (background == '\0') return;

	if (foreground == background) return;

	WORD attrib = 0;
	switch (foreground) {
	case '1':
		attrib += FOREGROUND_BLUE;
		break;
	case '2':
		attrib += FOREGROUND_RED;
		break;
	case '3':
		attrib += FOREGROUND_BLUE + FOREGROUND_RED;
		break;
	case '4':
		attrib += FOREGROUND_GREEN;
		break;
	case '5':
		attrib += FOREGROUND_BLUE + FOREGROUND_GREEN;
		break;
	case '6':
		attrib += FOREGROUND_GREEN + FOREGROUND_RED;
		break;
	case '7':
		attrib += FOREGROUND_BLUE + FOREGROUND_RED + FOREGROUND_GREEN;
		break;
	case '8':
		attrib += FOREGROUND_INTENSITY;
		break;
	case '9':
		attrib += FOREGROUND_BLUE + FOREGROUND_INTENSITY;
		break;

	case 'a':
	case 'A':
		attrib += FOREGROUND_RED + FOREGROUND_INTENSITY;
		break;
	case 'b':
	case 'B':
		attrib += FOREGROUND_BLUE + FOREGROUND_RED + FOREGROUND_INTENSITY;
		break;
	case 'C':
	case 'c':
		attrib += FOREGROUND_GREEN + FOREGROUND_INTENSITY;
		break;
	case 'D':
	case 'd':
		attrib += FOREGROUND_BLUE + FOREGROUND_GREEN + FOREGROUND_INTENSITY;
		break;
	case 'e':
	case 'E':
		attrib += FOREGROUND_GREEN + FOREGROUND_RED + FOREGROUND_INTENSITY;
		break;
	case 'F':
	case 'f':
		attrib += FOREGROUND_BLUE + FOREGROUND_RED + FOREGROUND_GREEN + FOREGROUND_INTENSITY;
		break;
	case '0':
	default:
		break;
	}

	switch (background) {
	case '1':
		attrib += BACKGROUND_BLUE;
		break;
	case '2':
		attrib += BACKGROUND_RED;
		break;
	case '3':
		attrib += BACKGROUND_BLUE + BACKGROUND_RED;
		break;
	case '4':
		attrib += BACKGROUND_GREEN;
		break;
	case '5':
		attrib += BACKGROUND_BLUE + BACKGROUND_GREEN;
		break;
	case '6':
		attrib += BACKGROUND_GREEN + BACKGROUND_RED;
		break;
	case '7':
		attrib += BACKGROUND_BLUE + BACKGROUND_RED + BACKGROUND_GREEN;
		break;
	case '8':
		attrib += BACKGROUND_INTENSITY;
		break;
	case '9':
		attrib += BACKGROUND_BLUE + BACKGROUND_INTENSITY;
		break;
	case 'A':
		attrib += BACKGROUND_RED + BACKGROUND_INTENSITY;
		break;
	case 'B':
		attrib += BACKGROUND_BLUE + BACKGROUND_RED + BACKGROUND_INTENSITY;
		break;
	case 'C':
		attrib += BACKGROUND_GREEN + BACKGROUND_INTENSITY;
		break;
	case 'D':
		attrib += BACKGROUND_BLUE + BACKGROUND_GREEN + BACKGROUND_INTENSITY;
		break;
	case 'E':
		attrib += BACKGROUND_GREEN + BACKGROUND_RED + BACKGROUND_INTENSITY;
		break;
	case 'F':
		attrib += BACKGROUND_BLUE + BACKGROUND_RED + BACKGROUND_GREEN + BACKGROUND_INTENSITY;
		break;
	case '0':
	default:
		break;
	}
	SetConsoleTextAttribute(h, attrib);
}

int __cdecl _ConvertCommandLineToArgcArgv( void )
{
    int cbCmdLine;
    int argc;
    PSTR pszSysCmdLine, pszCmdLine;
    
    // Set to no argv elements, in case we have to bail out
    _ppszArgv[0] = 0;

    // First get a pointer to the system's version of the command line, and
    // figure out how long it is.
    pszSysCmdLine = GetCommandLine();
    cbCmdLine = lstrlen( pszSysCmdLine );

    // Allocate memory to store a copy of the command line.  We'll modify
    // this copy, rather than the original command line.  Yes, this memory
    // currently doesn't explicitly get freed, but it goes away when the
    // process terminates.
    pszCmdLine = (char *)HeapAlloc( GetProcessHeap(), 0, cbCmdLine+1 );
    if ( !pszCmdLine )
        return 0;

    // Copy the system version of the command line into our copy
    lstrcpy( pszCmdLine, pszSysCmdLine );

    if ( '"' == *pszCmdLine )   // If command line starts with a quote ("),
    {                           // it's a quoted filename.  Skip to next quote.
        pszCmdLine++;
    
        _ppszArgv[0] = pszCmdLine;  // argv[0] == executable name
    
        while ( *pszCmdLine && (*pszCmdLine != '"') )
            pszCmdLine++;

        if ( *pszCmdLine )      // Did we see a non-NULL ending?
            *pszCmdLine++ = 0;  // Null terminate and advance to next char
        else
            return 0;           // Oops!  We didn't see the end quote
    }
    else    // A regular (non-quoted) filename
    {
        _ppszArgv[0] = pszCmdLine;  // argv[0] == executable name

        while ( *pszCmdLine && (' ' != *pszCmdLine) && ('\t' != *pszCmdLine) )
            pszCmdLine++;

        if ( *pszCmdLine )
            *pszCmdLine++ = 0;  // Null terminate and advance to next char
    }

    // Done processing argv[0] (i.e., the executable name).  Now do th
    // actual arguments

    argc = 1;

    while ( 1 )
    {
        // Skip over any whitespace
        while ( *pszCmdLine && (' ' == *pszCmdLine) || ('\t' == *pszCmdLine) )
            pszCmdLine++;

        if ( 0 == *pszCmdLine ) // End of command line???
            return argc;

        if ( '"' == *pszCmdLine )   // Argument starting with a quote???
        {
            pszCmdLine++;   // Advance past quote character

            _ppszArgv[ argc++ ] = pszCmdLine;
            _ppszArgv[ argc ] = 0;

            // Scan to end quote, or NULL terminator
            while ( *pszCmdLine && (*pszCmdLine != '"') )
                pszCmdLine++;
                
            if ( 0 == *pszCmdLine )
                return argc;
            
            if ( *pszCmdLine )
                *pszCmdLine++ = 0;  // Null terminate and advance to next char
        }
        else                        // Non-quoted argument
        {
            _ppszArgv[ argc++ ] = pszCmdLine;
            _ppszArgv[ argc ] = 0;

            // Skip till whitespace or NULL terminator
            while ( *pszCmdLine && (' '!=*pszCmdLine) && ('\t'!=*pszCmdLine) )
                pszCmdLine++;
            
            if ( 0 == *pszCmdLine )
                return argc;
            
            if ( *pszCmdLine )
                *pszCmdLine++ = 0;  // Null terminate and advance to next char
        }

        if ( argc >= (_MAX_CMD_LINE_ARGS) )
            return argc;
    }
}
}